(define-module (bugafriend room)
  #:use-module (goblins)
  #:use-module (goblins actor-lib pubsub)
  #:export (^room ^room-presence))

(define (^room bcom creator-presence)
  "The creator owns the canonical room which publishes to subscribers."
  (define pubsub (spawn ^pubsub (list creator-presence)))
  (methods
   [(add-user presence)
    ($ pubsub 'subscribe presence)
    ($ pubsub 'publish 'join presence)]
   [(kick-user presence)
    ($ pubsub 'unsubscribe presence)
    ($ pubsub 'publish 'leave presence)]
   [(say presence message)
    ($ pubsub 'publish 'say presence message)]
   [(me presence message)
    ($ pubsub 'publish 'me presence message)]))

(define (^room-presence bcom name)
  "Each user has a presence in the room"
  (methods
   [(name) name]
   [(join user)
    (format #t "~a joined." user)]
   [(leave user)
    (format #t "~a left." user)]
   [(say user message)
    (format #t "~a: ~a\n" user message)]
   [(me user message)
    (format #t "* ~a ~a\n" user message)]))
